//+------------------------------------------------------------------+
//|                                                     BarTimer.mq4 |
//|                               Copyright  2008, Art Royal s.r.o. |
//|                                           Author: Vasyl Gumenyak |  
//|                                           http://www.jiport.com/ |
//+------------------------------------------------------------------+
#property copyright "Copyright  2008, Art Royal s.r.o."
#property link      "http://www.jiport.com/"

#property indicator_chart_window
#property indicator_buffers 0

extern int myPeriod=60;
extern string FontName="Arial";
extern int FontSize=12;
extern color FontColor=Yellow;
extern int Corner=0;// values [0-3] -  
extern int XDistance=250;// x    
extern int YDistance=30;// y    

int lenbase;
string s_base=":...:...:...:...:";//      

int init()
  {
   lenbase=StringLen(s_base);
   return(0);
  }

int deinit()
  {
   if (ObjectFind("BarTimer_"+myPeriod) != -1) ObjectDelete("BarTimer_"+myPeriod);
   return(0);
  }

//+------------------------------------------------------------------+
//|                        |
//|        ,                     |
//|                                    |
//|                                  |
//+------------------------------------------------------------------+
int start()
  {
   int i=0,sec=0;
   double pc=0.0;
   string time="",s_end="",s_beg="";
   if (ObjectFind("BarTimer_"+myPeriod) == -1) {//     -    
     ObjectCreate("BarTimer_"+myPeriod , OBJ_LABEL,0,0,0);
     ObjectSet("BarTimer_"+myPeriod, OBJPROP_XDISTANCE, XDistance);
     ObjectSet("BarTimer_"+myPeriod, OBJPROP_YDISTANCE, YDistance);
     ObjectSet("BarTimer_"+myPeriod, OBJPROP_CORNER, Corner);
   }
   sec=TimeCurrent()-iTime(Symbol(),myPeriod,0);//      
   i=(lenbase-1)*sec/(myPeriod*60);//  
   pc=100.0*sec/(myPeriod*60);//      
   if(i>lenbase-1) i=lenbase-1;//    
   if(i>0) s_beg=StringSubstr(s_base,0,i);
   if(i<lenbase-1) s_end=StringSubstr(s_base,i+1,lenbase-i-1);
   time=StringConcatenate(s_beg,"|",s_end,"  ",DoubleToStr(pc,0),"%  (",myPeriod,")");
   ObjectSetText("BarTimer_"+myPeriod, time, FontSize, FontName, FontColor);

   return(0);
  }
//+------------------------------------------------------------------+