//+------------------------------------------------------------------+ 
//|   TRO_BB_Trend_History                                           | 
//|                                                                  | 
//|   Copyright  2009, Avery T. Horton, Jr. aka TheRumpledOne       |
//|                                                                  |
//|   PO BOX 43575, TUCSON, AZ 85733                                 |
//|                                                                  |
//|   GIFTS AND DONATIONS ACCEPTED                                   | 
//|   All my indicators should be considered donationware. That is   |
//|   you are free to use them for your personal use, and are        |
//|   under no obligation to pay for them. However, if you do find   |
//|   this or any of my other indicators help you with your trading  |
//|   then any Gift or Donation as a show of appreciation is         |
//|   gratefully accepted.                                           |
//|                                                                  |
//|   Gifts or Donations also keep me motivated in producing more    |
//|   great free indicators. :-)                                     |
//|                                                                  |
//|   PayPal - THERUMPLEDONE@GMAIL.COM                               |  
//+------------------------------------------------------------------+ 
//| Use http://therumpledone.mbtrading.com/fx/ as your forex broker  |  
//| ...tell them therumpledone sent you!                             |  
//+------------------------------------------------------------------+ 


#property  copyright "Copyright  2009, Avery T. Horton, Jr. aka TRO" 
#property  link      "http://www.therumpledone.com/" 
 

#property indicator_separate_window
#property indicator_buffers 5
#property indicator_color1 Lime    
#property indicator_color2 DarkGreen         
#property indicator_color3 Yellow      
#property indicator_color4 Maroon    
#property indicator_color5 Red        
   

//---- parameters
 
extern int    myPriceTypeUpper = 0;
extern int    myPriceTypeLower = 0;
extern int    BandsPeriod=20;
extern int    BandsShift=0;
extern double BandsDeviations=2.0;


extern color colorBreakOutUp   =  Lime ;
extern color colorBreakOutDn   =  Red ;
extern color colorTrendingUp   =  Green ;
extern color colorTrendingDn   =  Crimson ;
extern color colorCounterTrend =  DimGray ;

//---- buffers

   double     ExtBuffer0[];   
   double     ExtBuffer1[];
   double     ExtBuffer2[];
   double     ExtBuffer3[]; 
   double     ExtBuffer4[];   

 
//+------------------------------------------------------------------+ 

string symbol, tChartPeriod,  tShortName ;  
int    digits, period , i ; 

double   cUpperBB, pUpperBB, cLowerBB, pLowerBB, open, high, low, close ;

bool BreakOutUp, BreakOutDn, TrendingUp, TrendingDn, CounterTrend ; 
bool Expanding, Contracting, Neither ; 
//+------------------------------------------------------------------+

string TimeFrameToString(int tf)
{
   string tfs;
   switch(tf) {
      case PERIOD_MN1: tfs="MN"; break;
      case PERIOD_M1:  tfs="M1"  ; break;
      case PERIOD_M5:  tfs="M5"  ; break;
      case PERIOD_M15: tfs="M15" ; break;
      case PERIOD_M30: tfs="M30" ; break;
      case PERIOD_H1:  tfs="H1"  ; break;
      case PERIOD_H4:  tfs="H4"  ; break;
      case PERIOD_D1:  tfs="D1"  ; break;
      case PERIOD_W1:  tfs="W1"  ; break;
   }
   return(tfs);
} 

//+------------------------------------------------------------------+

int init()
{


   period       = Period() ;   
   symbol       = Symbol() ;


  tChartPeriod = TimeFrameToString(period) ; 

   SetIndexBuffer(0,ExtBuffer0);
   SetIndexBuffer(1,ExtBuffer1);
   SetIndexBuffer(2,ExtBuffer2);
   SetIndexBuffer(3,ExtBuffer3);
   SetIndexBuffer(4,ExtBuffer4);
 
   
   SetIndexStyle(0,DRAW_HISTOGRAM, EMPTY, 4, colorBreakOutUp);
   SetIndexStyle(1,DRAW_HISTOGRAM, EMPTY, 4, colorBreakOutDn);
   SetIndexStyle(2,DRAW_HISTOGRAM, EMPTY, 4, colorTrendingUp);
   SetIndexStyle(3,DRAW_HISTOGRAM, EMPTY, 4, colorTrendingDn);
   SetIndexStyle(4,DRAW_HISTOGRAM, EMPTY, 4, colorCounterTrend);
 
   
   

IndicatorShortName("TRO_BB_Trend_History" );
    
return(0);
}

//+------------------------------------------------------------------+
int deinit()
  {
   return(0);
  }
  
//+------------------------------------------------------------------+
int start()
  {
  
   int counted_bars=IndicatorCounted();
   
   if(counted_bars<0) return(-1);
   
   if(counted_bars>0) counted_bars--;
   
   int bars=Bars-counted_bars;


//---- main calculation loop

while(bars>=0)
{          
       
 
close     = iClose(symbol,period,bars) ;
high      = iHigh(symbol,period,bars) ; 
low       = iLow(symbol,period,bars) ;

cUpperBB  = iBands(symbol,period,BandsPeriod,BandsDeviations,0,myPriceTypeUpper,MODE_UPPER,bars);       
pUpperBB  = iBands(symbol,period,BandsPeriod,BandsDeviations,0,myPriceTypeUpper,MODE_UPPER,bars+1); 

cLowerBB  = iBands(symbol,period,BandsPeriod,BandsDeviations,0,myPriceTypeLower,MODE_LOWER,bars);       
pLowerBB  = iBands(symbol,period,BandsPeriod,BandsDeviations,0,myPriceTypeLower,MODE_LOWER,bars+1); 
 

BreakOutUp   = ( close > cUpperBB && low   < cUpperBB ) ; 
BreakOutDn   = ( high  > cLowerBB && close < cLowerBB ) ; 

TrendingUp   = close > cUpperBB && close > pUpperBB ;
TrendingDn   = close < cLowerBB && close < cLowerBB ;

CounterTrend = close > cLowerBB && close < cUpperBB ; 


while(true)
{
      
  if (BreakOutUp)   { PlotHist(4,0,0,0,0,bars) ; break; }
  if (BreakOutDn)   { PlotHist(0,4,0,0,0,bars) ; break; }
  if (TrendingUp)   { PlotHist(0,0,4,0,0,bars) ; break; }
  if (TrendingDn)   { PlotHist(0,0,0,4,0,bars) ; break; }
  if (CounterTrend) { PlotHist(0,0,0,0,4,bars) ; break; }

  PlotHist(0,0,0,0,4,bars) ; break; 

} // while 
       
bars--; }
 
return(0);

}

//+------------------------------------------------------------------+
      
void PlotHist(int a,int b,int c,int d,int e, int bars)
{

ExtBuffer0[bars]=a;    
ExtBuffer1[bars]=b;
ExtBuffer2[bars]=c;
ExtBuffer3[bars]=d;
ExtBuffer4[bars]=e;
 
}

//+------------------------------------------------------------------+