//+------------------------------------------------------------------+ 
//|   TRO_Range_BreakOut                                             | 
//|                                                                  | 
//|   Copyright  2009, Avery T. Horton, Jr. aka TheRumpledOne       |
//|                                                                  |
//|   PO BOX 43575, TUCSON, AZ 85733                                 |
//|                                                                  |
//|   GIFTS AND DONATIONS ACCEPTED                                   | 
//|   All my indicators should be considered donationware. That is   |
//|   you are free to use them for your personal use, and are        |
//|   under no obligation to pay for them. However, if you do find   |
//|   this or any of my other indicators help you with your trading  |
//|   then any Gift or Donation as a show of appreciation is         |
//|   gratefully accepted.                                           |
//|                                                                  |
//|   Gifts or Donations also keep me motivated in producing more    |
//|   great free indicators. :-)                                     |
//|                                                                  |
//|   PayPal - THERUMPLEDONE@GMAIL.COM                               |  
//+------------------------------------------------------------------+ 
//| Use http://therumpledone.mbtrading.com/fx/ as your forex broker  |  
//| ...tell them therumpledone sent you!                             |  
//+------------------------------------------------------------------+ 


#property  copyright "Copyright  2009, Avery T. Horton, Jr. aka TRO" 
#property  link      "http://www.therumpledone.com/" 
 
 
#property indicator_chart_window
#property indicator_buffers 2
#property indicator_color1 Green 
#property indicator_color2 Red


extern bool   Show.PriceBox  = true ;
extern int    myBoxWidth  = 3;


extern int myPeriod  = 0;
extern int myShift   = 1 ;
extern int ATRPeriod = 1 ;

extern int WingDingUp = 119;  
extern int WingDingDn = 119; // 171

//---- buffers
double UpperBand[];
double LowerBand[];


//----
double H,L,H1,L1,C, UpTrigger, DnTrigger, range ;

bool Up, Dn ;

string symbol, tChartPeriod,  tShortName ;  
int    digits, period, digits2  ; 
double point ;

datetime Trigger ;

//+------------------------------------------------------------------+
int init()
  {

   if(myPeriod == 0) { period = Period() ; } else { period = myPeriod ; }    
   tChartPeriod =  TimeFrameToString(period) ;
   symbol       =  Symbol() ;
   digits       =  Digits ;   
   point        =  Point ;  
   
   tShortName = "RBO" + symbol + tChartPeriod  ; 
  
  SetIndexBuffer(0, UpperBand);
   SetIndexStyle(0,DRAW_ARROW); 
   SetIndexArrow(0,WingDingUp); 
  SetIndexEmptyValue(0, EMPTY_VALUE);

  SetIndexBuffer(1, LowerBand);
   SetIndexStyle(1,DRAW_ARROW); 
   SetIndexArrow(1,WingDingDn); 
  SetIndexEmptyValue(1, EMPTY_VALUE);  
      
//----
//   Comment("TRO BREAKOUT");
   deinit();
   
   return(0);
  }
  

//+------------------------------------------------------------------+
int start()
  {
   int i, dayi, counted_bars = IndicatorCounted();
//---- check for possible errors
   if(counted_bars < 0) 
       return(-1);
//---- last counted bar will be recounted
   if(counted_bars > 0) 
       counted_bars--;  
   int limit = Bars - counted_bars;
   
   
   Up = false;
   Dn = false; 
   
//----   
   for(i = limit - 1; i >= 0; i--)
     {
//       dayi = iBarShift(Symbol(), myPeriod, Time[i], false);
       
       H1=iHigh(symbol, period, i+myShift );
       L1=iLow(symbol, period, i+myShift);
       
       range = iATR(symbol, period,ATRPeriod,i+1) ;
       
       C = iClose(symbol, period, i ); 
       H = iHigh(symbol, period, i );
       L = iLow(symbol, period,i ); 
            
       //----

       UpperBand[i] = L + range ;
       LowerBand[i] = H - range ;  
 
                      
    }
    
   if(Show.PriceBox) { DoBox() ; }
   return(0);
  }
  
//+------------------------------------------------------------------+

void ObDeleteObjectsByPrefix(string Prefix)
  {
   int L = StringLen(Prefix);
   int i = 0; 
   while(i < ObjectsTotal())
     {
       string ObjName = ObjectName(i);
       if(StringSubstr(ObjName, 0, L) != Prefix) 
         { 
           i++; 
           continue;
         }
       ObjectDelete(ObjName);
     }
  }
    
//+------------------------------------------------------------------+
int deinit()
  {
        
   ObDeleteObjectsByPrefix("RBO");  
   TRO() ;
   return(0);
  }


//+--------- TRO MODIFICATION ---------------------------------------+  
void DoBox()    
{


       if (ObjectFind(tShortName+"01") != 0)
      {
          ObjectCreate(tShortName+"01",OBJ_ARROW,0,Time[0],UpperBand[0]);
          ObjectSet(tShortName+"01",OBJPROP_ARROWCODE,SYMBOL_RIGHTPRICE);
          ObjectSet(tShortName+"01",OBJPROP_COLOR,indicator_color1);  
          ObjectSet(tShortName+"01",OBJPROP_WIDTH,myBoxWidth);  
      } 
      else
      {
         ObjectMove(tShortName+"01",0,Time[0],UpperBand[0]);
         ObjectSet(tShortName+"01",OBJPROP_COLOR,indicator_color1);  
      }

       if (ObjectFind(tShortName+"02") != 0)
      {
          ObjectCreate(tShortName+"02",OBJ_ARROW,0,Time[0],LowerBand[0]);
          ObjectSet(tShortName+"02",OBJPROP_ARROWCODE,SYMBOL_RIGHTPRICE);
          ObjectSet(tShortName+"02",OBJPROP_COLOR,indicator_color2);  
          ObjectSet(tShortName+"02",OBJPROP_WIDTH,myBoxWidth);  
      } 
      else
      {
         ObjectMove(tShortName+"02",0,Time[0],LowerBand[0]);
         ObjectSet(tShortName+"02",OBJPROP_COLOR,indicator_color2);  
      }




      

                
   return(0);
}


//+--------- TRO MODIFICATION ---------------------------------------+  

string TimeFrameToString(int tf)
{
   string tfs;
   switch(tf) {
      case PERIOD_M1:  tfs="M1"  ; break;
      case PERIOD_M5:  tfs="M5"  ; break;
      case PERIOD_M15: tfs="M15" ; break;
      case PERIOD_M30: tfs="M30" ; break;
      case PERIOD_H1:  tfs="H1"  ; break;
      case PERIOD_H4:  tfs="H4"  ; break;
      case PERIOD_D1:  tfs="D1"  ; break;
      case PERIOD_W1:  tfs="W1"  ; break;
      case PERIOD_MN1: tfs="MN";
   }
   return(tfs);
} 
//+------------------------------------------------------------------+  
void TRO()
{   
   
   string tObjName03    = "TROTAG"  ;  
   ObjectCreate(tObjName03, OBJ_LABEL, 0, 0, 0);//HiLow LABEL
   ObjectSetText(tObjName03, CharToStr(78) , 12 ,  "Wingdings",  DimGray );
   ObjectSet(tObjName03, OBJPROP_CORNER, 3);
   ObjectSet(tObjName03, OBJPROP_XDISTANCE, 5 );
   ObjectSet(tObjName03, OBJPROP_YDISTANCE, 5 );  
}

//+------------------------------------------------------------------+ 
 
  /*
  
         if( L <= DnTrigger && Dn == False ) {
         LowerBand[i] = L ; Dn = True;  Up = False; }

       if( H >= UpTrigger && Up == False  ) {
         UpperBand[i] = H ; Dn = False;  Up = True;  }
*/        