//+------------------------------------------------------------------+ 
//|   TRO_LODHOD                                                     | 
//|                                                                  | 
//|   Copyright  2009, Avery T. Horton, Jr. aka TheRumpledOne       |
//|                                                                  |
//|   PO BOX 43575, TUCSON, AZ 85733                                 |
//|                                                                  |
//|   GIFTS AND DONATIONS ACCEPTED                                   | 
//|   All my indicators should be considered donationware. That is   |
//|   you are free to use them for your personal use, and are        |
//|   under no obligation to pay for them. However, if you do find   |
//|   this or any of my other indicators help you with your trading  |
//|   then any Gift or Donation as a show of appreciation is         |
//|   gratefully accepted.                                           |
//|                                                                  |
//|   Gifts or Donations also keep me motivated in producing more    |
//|   great free indicators. :-)                                     |
//|                                                                  |
//|   PayPal - THERUMPLEDONE@GMAIL.COM                               |  
//+------------------------------------------------------------------+ 
//| Use http://therumpledone.mbtrading.com/fx/ as your forex broker  |  
//| ...tell them therumpledone sent you!                             |  
//+------------------------------------------------------------------+ 


#property  copyright "Copyright  2009, Avery T. Horton, Jr. aka TRO" 
#property  link      "http://www.therumpledone.com/" 


//----
#property indicator_chart_window
#property indicator_buffers 3
//#property indicator_color1  Magenta
//#property indicator_color2  Aqua
//---- input parameters

extern int       myHODCode = 244;
extern int       myLODCode = 244;

extern int       myLineWidth = 2;

extern color colorHOD  = Red ;
extern color colorLOD  = Blue ;


//---- buffers
double ExtMapBuffer1[];
double ExtMapBuffer2[];
  

string symbol, tChartPeriod,  tShortName ;  
int    digits, period , i, shift ; 

double  open, high, low, close , open1, high1, low1, close1, body, wick, tail, top, bottom;
double range, onethirdrange ;

bool BreakOutUp, BreakOutDn, Bull, Bear, ReverseUp, ReverseDn ; 
bool WDL_Long, WDL_Short ; 


//+------------------------------------------------------------------+
int init()
  {

   period       = Period() ;   
 
   symbol       = Symbol() ;  
  
//---- indicators
   SetIndexStyle(0,DRAW_ARROW,STYLE_SOLID,myLineWidth,colorHOD);
   SetIndexBuffer(0,ExtMapBuffer1);
   SetIndexArrow(0,myHODCode);// 234
   SetIndexStyle(1,DRAW_ARROW,STYLE_SOLID,myLineWidth,colorLOD);
   SetIndexBuffer(1,ExtMapBuffer2);
   SetIndexArrow(1,myLODCode);// 235

//----
   deinit();
   
   return(0);
  }
  
//+------------------------------------------------------------------+

void ObDeleteObjectsByPrefix(string Prefix)
  {
   int L = StringLen(Prefix);
   int i = 0; 
   while(i < ObjectsTotal())
     {
       string ObjName = ObjectName(i);
       if(StringSubstr(ObjName, 0, L) != Prefix) 
         { 
           i++; 
           continue;
         }
       ObjectDelete(ObjName);
     }
  }
    
//+------------------------------------------------------------------+
int deinit()
  {
    
   ObDeleteObjectsByPrefix("LODHOD");          
   TRO() ;
   
   return(0);
  }
  
//+------------------------------------------------------------------+
int start()
  {   
  int    i,k,counted_bars=IndicatorCounted();
   double deviation;
   double sum,oldval,newres;
//----
  

//----
   int limit=Bars-counted_bars;
   if(counted_bars>0) limit++;
   
for(i=0; i<limit; i++)
{

ExtMapBuffer1[i] = EMPTY_VALUE ;
ExtMapBuffer2[i] = EMPTY_VALUE ; 
     
open      = iOpen(symbol,period,i) ;      
close     = iClose(symbol,period,i) ;
high      = iHigh(symbol,period,i) ; 
low       = iLow(symbol,period,i) ;

shift      = iBarShift(symbol,PERIOD_D1,Time[i]);

open1      = iOpen(symbol,PERIOD_D1,shift) ; 
close1     = iClose(symbol,PERIOD_D1,shift) ;
high1      = iHigh(symbol,PERIOD_D1,shift) ; 
low1       = iLow(symbol,PERIOD_D1,shift) ; 
 
 

if( high == high1 ) { ExtMapBuffer1[i] = high + 5 * Point ; }
if( low  == low1  ) { ExtMapBuffer2[i] = low - 5 * Point ; } 
          
} // for 
//----


    
   
   return(0);
  } 
//+------------------------------------------------------------------+  
void TRO()
{   
   
   string tObjName03    = "TROTAG"  ;  
   ObjectCreate(tObjName03, OBJ_LABEL, 0, 0, 0);//HiLow LABEL
   ObjectSetText(tObjName03, CharToStr(78) , 12 ,  "Wingdings",  DimGray );
   ObjectSet(tObjName03, OBJPROP_CORNER, 3);
   ObjectSet(tObjName03, OBJPROP_XDISTANCE, 5 );
   ObjectSet(tObjName03, OBJPROP_YDISTANCE, 5 );  
}


//+------------------------------------------------------------------+

/*

                                       
   Comment( 
    "symbol=", symbol,  "\n",
    "period=", period,  "\n",  
    "wick=", DoubleToStr(wick, Digits), "\n", 
    "tail=", DoubleToStr(tail, Digits), "\n",     
    "body=", DoubleToStr(body, Digits), "\n",     
    "BreakOutUp=", BreakOutUp,  "\n",  
    "BreakOutDn=", BreakOutDn,  "\n",  
    "open=", DoubleToStr(open, Digits), "\n", 
    "high=", DoubleToStr(high, Digits), "\n", 
    "low=", DoubleToStr(low, Digits), "\n", 
    "close=", DoubleToStr(close, Digits), "\n",    
    "WDL_Long=", WDL_Long,  "\n",  
    "WDL_Short=", WDL_Short,  "\n",
    "range=", DoubleToStr(range, Digits), "\n", 
    "onethirdrange=", DoubleToStr(onethirdrange, Digits), "\n",       
 
     
    "") ;
    
*/   

