//+------------------------------------------------------------------+ 
//|   TRO_Multi_Meter_MACD                                           | 
//|                                                                  | 
//|   Copyright  2008, Avery T. Horton, Jr. aka TheRumpledOne       |
//|                                                                  |
//|   PO BOX 43575, TUCSON, AZ 85733                                 |
//|                                                                  |
//|   GIFT AND DONATIONS ACCEPTED                                    | 
//|                                                                  |
//|   therumpledone@gmail.com                                        |  
//+------------------------------------------------------------------+ 
//|                                                                  |
//| go to www.kreslik.com for the latest indicator updates           |  
//+------------------------------------------------------------------+ 
//|                                                                  |
//| Use mbtrading as your forex broker...                            |  
//| http://therumpledone.mbtrading.com/fx/demo.asp                   |  
//+------------------------------------------------------------------+ 

#property indicator_chart_window

extern bool Show_Heading = true;

 
extern string IndName = "MACD" ; // change

extern bool Corner_of_Chart_RIGHT_TOP = true;

extern int Shift_UP_DN = 100; 
extern int Adjust_Side_to_side  = 20; // 20

extern color BarLabel_color = LightBlue;
extern color CommentLabel_color = LightBlue;


extern int fast_ema_period = 10 ;
extern int slow_ema_period = 20 ;
extern int signal_period   = 5 ;
extern int PriceField=0; 

extern double Level5 =  1.0 ;
extern double Level4 =  0.5 ;
extern double Level3 =  0 ;
extern double Level2 =  -0.5 ;
extern double Level1 =  -1.0;
extern double Level0 =  -1.5 ;

extern color colorUpA =  Lime ;
extern color colorDnA =  Green ;
extern color colorXaA  = LimeGreen  ;
extern color colorXbA  = Yellow  ;
extern color colorUpB =  Pink ;
extern color colorDnB =  Red ;
extern color colorXaB  = Orange  ;
extern color colorXbB  = FireBrick  ;



string ObjHead01,ObjHead02,ObjHead03,ObjHead04,ObjHead05,ObjHead06,ObjHead07,ObjHead08,ObjHead09,ObjHead10,ObjHead11;  

string Obj0001,Obj0002,Obj0003,Obj0004,Obj0005,Obj0006,Obj0007,Obj0008,Obj0009,Obj0010,Obj0011;  

int    MAMode;
string strMAType, LabelTime ;

string symbol, tChartPeriod,  tShortName ;  
int    digits, period  ; 
 

   string MACD_ObjHead01 ="M1 " ;
   string MACD_ObjHead02 ="M5  " ;     
   string MACD_ObjHead03 ="M15 " ;
   string MACD_ObjHead04 =" M30 " ;
   string MACD_ObjHead05 ="H1  " ;     
   string MACD_ObjHead06 ="H4  " ;
   string MACD_ObjHead07 ="D1  " ;
   string MACD_ObjHead08 ="W1  " ;
   string MACD_ObjHead09 ="MN1" ;   
   
   
bool xAbove, xBelow ;   
   
//+------------------------------------------------------------------+

int init()
  {
  

   period       = Period() ;   
   tChartPeriod = TimeFrameToString(period) ;
   symbol       = Symbol() ;
   LabelTime    = symbol + tChartPeriod  ;  
 
   ObjHead01 = "MACDColHead01" ; 
   ObjHead02 = "MACDColHead02" ; 
   ObjHead03 = "MACDColHead03" ; 
   ObjHead04 = "MACDColHead04" ; 
   ObjHead05 = "MACDColHead05" ; 
   ObjHead06 = "MACDColHead06" ; 
   ObjHead07 = "MACDColHead07" ; 
   ObjHead08 = "MACDColHead08" ; 
   ObjHead09 = "MACDColHead09" ; 
         
   Obj0002 = "MACDSignalM1t" ; 
   Obj0003 = "MACDSignalM1" ;  
   Obj0004 = "MACDSignalM5" ;  
   Obj0005 = "MACDSignalM15" ;    
   Obj0006 = "MACDSignalM30" ;    
   Obj0007 = "MACDSignalM60" ;     
   Obj0008 = "MACDSignalM240" ;   
   Obj0009 = "MACDSignalM1440" ;   
   Obj0010 = "MACDSignalW1" ;  
   Obj0011 = "MACDSignalMN1" ;   
   
   return(0);
  }

//+------------------------------------------------------------------+
//| Custom indicator iteration function                              |
//+------------------------------------------------------------------+
int start()
  {    


        
    if (Corner_of_Chart_RIGHT_TOP == true)
    { int Col01x = 170+Adjust_Side_to_side ;                 
      int Col01y = 28+Shift_UP_DN ;
    }
    if (Corner_of_Chart_RIGHT_TOP == false)
   { Col01x = 159+Adjust_Side_to_side ;       
     Col01y = 24+Shift_UP_DN ;
    } 
    
   int ColAdj = -20 ; 
   int Col02x = Col01x + ColAdj ;   
   int Col03x = Col01x + ColAdj*2 ; 
   int Col04x = Col01x + ColAdj*3 ; 
   int Col05x = Col01x + ColAdj*4 ; 
   int Col06x = Col01x + ColAdj*5 ; 
   int Col07x = Col01x + ColAdj*6 ;    
   int Col08x = Col01x + ColAdj*7 ; 
   int Col09x = Col01x + ColAdj*8 ;     
   
   if ( Show_Heading) {        
   ObjectCreate(ObjHead01, OBJ_LABEL, 0, 0, 0);
   ObjectSetText(ObjHead01,MACD_ObjHead01 , 7, "Tahoma Narrow", BarLabel_color);
   ObjectSet(ObjHead01, OBJPROP_CORNER, Corner_of_Chart_RIGHT_TOP);
   ObjectSet(ObjHead01, OBJPROP_XDISTANCE, Col01x);
   ObjectSet(ObjHead01, OBJPROP_YDISTANCE, Col01y); 

   ObjectCreate(ObjHead02, OBJ_LABEL, 0, 0, 0);
   ObjectSetText(ObjHead02,MACD_ObjHead02 , 7, "Tahoma Narrow", BarLabel_color);
   ObjectSet(ObjHead02, OBJPROP_CORNER, Corner_of_Chart_RIGHT_TOP);
   ObjectSet(ObjHead02, OBJPROP_XDISTANCE, Col02x);
   ObjectSet(ObjHead02, OBJPROP_YDISTANCE, Col01y);   
       
   ObjectCreate(ObjHead03, OBJ_LABEL, 0, 0, 0);
   ObjectSetText(ObjHead03,MACD_ObjHead03 , 7, "Tahoma Narrow", BarLabel_color);
   ObjectSet(ObjHead03, OBJPROP_CORNER, Corner_of_Chart_RIGHT_TOP);
   ObjectSet(ObjHead03, OBJPROP_XDISTANCE, Col03x);
   ObjectSet(ObjHead03, OBJPROP_YDISTANCE, Col01y); 
 
   ObjectCreate(ObjHead04, OBJ_LABEL, 0, 0, 0);
   ObjectSetText(ObjHead04,MACD_ObjHead04 , 7, "Tahoma Narrow", BarLabel_color);
   ObjectSet(ObjHead04, OBJPROP_CORNER, Corner_of_Chart_RIGHT_TOP);
   ObjectSet(ObjHead04, OBJPROP_XDISTANCE, Col04x);
   ObjectSet(ObjHead04, OBJPROP_YDISTANCE, Col01y); 
   
   ObjectCreate(ObjHead05, OBJ_LABEL, 0, 0, 0);
   ObjectSetText(ObjHead05,MACD_ObjHead05 , 7, "Tahoma Narrow", BarLabel_color);
   ObjectSet(ObjHead05, OBJPROP_CORNER, Corner_of_Chart_RIGHT_TOP);
   ObjectSet(ObjHead05, OBJPROP_XDISTANCE, Col05x);
   ObjectSet(ObjHead05, OBJPROP_YDISTANCE, Col01y); 
            
   ObjectCreate(ObjHead06, OBJ_LABEL, 0, 0, 0);
   ObjectSetText(ObjHead06,MACD_ObjHead06 , 7, "Tahoma Narrow", BarLabel_color);
   ObjectSet(ObjHead06, OBJPROP_CORNER, Corner_of_Chart_RIGHT_TOP);
   ObjectSet(ObjHead06, OBJPROP_XDISTANCE, Col06x);
   ObjectSet(ObjHead06, OBJPROP_YDISTANCE, Col01y); 

   ObjectCreate(ObjHead07, OBJ_LABEL, 0, 0, 0);
   ObjectSetText(ObjHead07,MACD_ObjHead07 , 7, "Tahoma Narrow", BarLabel_color);
   ObjectSet(ObjHead07, OBJPROP_CORNER, Corner_of_Chart_RIGHT_TOP);
   ObjectSet(ObjHead07, OBJPROP_XDISTANCE, Col07x);
   ObjectSet(ObjHead07, OBJPROP_YDISTANCE, Col01y); 
         
   ObjectCreate(ObjHead08, OBJ_LABEL, 0, 0, 0);
   ObjectSetText(ObjHead08,MACD_ObjHead08 , 7, "Tahoma Narrow", BarLabel_color);
   ObjectSet(ObjHead08, OBJPROP_CORNER, Corner_of_Chart_RIGHT_TOP);
   ObjectSet(ObjHead08, OBJPROP_XDISTANCE, Col08x);
   ObjectSet(ObjHead08, OBJPROP_YDISTANCE, Col01y); 

   ObjectCreate(ObjHead09, OBJ_LABEL, 0, 0, 0);
   ObjectSetText(ObjHead09,MACD_ObjHead09 , 7, "Tahoma Narrow", BarLabel_color);
   ObjectSet(ObjHead09, OBJPROP_CORNER, Corner_of_Chart_RIGHT_TOP);
   ObjectSet(ObjHead09, OBJPROP_XDISTANCE, Col09x);
   ObjectSet(ObjHead09, OBJPROP_YDISTANCE, Col01y); 
       
} // Show_Heading

 //*******************   change for  your indicator ********************
 
    
    string M1_MACD= "-",M5_MACD= "-", M15_MACD= "-", M30_MACD= "-", H1_MACD= "-", H4_MACD= "-", D1_MACD= "-",PRC1, W1_MACD= "-", MN1_MACD= "-";

    color  color_MACDm1,color_MACDm5,color_MACDm15,color_MACDm30,color_MACDH1,color_MACDH4,color_MACDD1,color_MACDW1,color_MACDMN1;     
         

   //MACD Signals

string symbol = Symbol() ;

 color_MACDm1  = ColorMACD( symbol, PERIOD_M1  ) ;
 color_MACDm5  = ColorMACD( symbol, PERIOD_M5  ) ;

// Comment("M5 Pivot =", DoubleToStr(cPivot,Digits) ); 
 
 color_MACDm15 = ColorMACD( symbol, PERIOD_M15  ) ;
 

 
 color_MACDm30 = ColorMACD( symbol, PERIOD_M30  ) ;
 color_MACDH1  = ColorMACD( symbol, PERIOD_H1  ) ;
 color_MACDH4  = ColorMACD( symbol, PERIOD_H4  ) ;
 color_MACDD1  = ColorMACD( symbol, PERIOD_D1  ) ;
 color_MACDW1  = ColorMACD( symbol, PERIOD_W1  ) ;
 color_MACDMN1 = ColorMACD( symbol, PERIOD_MN1  ) ;

               
    
 //*******************          
    
    int Col00x = Col01x + 20 ;
    int Col00y = 50+Shift_UP_DN ;
    
    Col01y = 20+Shift_UP_DN ;
    

           ObjectCreate(Obj0002, OBJ_LABEL, 0, 0, 0);
   ObjectSetText(Obj0002,IndName, 7, "Tahoma Narrow",  BarLabel_color);  
   ObjectSet(Obj0002, OBJPROP_CORNER, Corner_of_Chart_RIGHT_TOP);
   ObjectSet(Obj0002, OBJPROP_XDISTANCE, Col00x);
   ObjectSet(Obj0002, OBJPROP_YDISTANCE, Col00y);  // 50+Shift_UP_DN

      
           ObjectCreate(Obj0003, OBJ_LABEL, 0, 0, 0);
   ObjectSetText(Obj0003, M1_MACD, 40, "Tahoma Narrow",  color_MACDm1);
   ObjectSet(Obj0003, OBJPROP_CORNER, Corner_of_Chart_RIGHT_TOP);
   ObjectSet(Obj0003, OBJPROP_XDISTANCE, Col01x);
   ObjectSet(Obj0003, OBJPROP_YDISTANCE, Col01y); 

          
           ObjectCreate(Obj0004, OBJ_LABEL, 0, 0, 0);
   ObjectSetText(Obj0004, M5_MACD, 40, "Tahoma Narrow",  color_MACDm5);
   ObjectSet(Obj0004, OBJPROP_CORNER, Corner_of_Chart_RIGHT_TOP);
   ObjectSet(Obj0004, OBJPROP_XDISTANCE, Col02x);
   ObjectSet(Obj0004, OBJPROP_YDISTANCE, Col01y); 
      

   ObjectCreate(Obj0005, OBJ_LABEL, 0, 0, 0);
   ObjectSetText(Obj0005, M15_MACD, 40, "Tahoma Narrow",  color_MACDm15);
   ObjectSet(Obj0005, OBJPROP_CORNER, Corner_of_Chart_RIGHT_TOP);
   ObjectSet(Obj0005, OBJPROP_XDISTANCE, Col03x);
   ObjectSet(Obj0005, OBJPROP_YDISTANCE, Col01y); 
      

   ObjectCreate(Obj0006, OBJ_LABEL, 0, 0, 0);
   ObjectSetText(Obj0006, M30_MACD, 40, "Tahoma Narrow",  color_MACDm30);
   ObjectSet(Obj0006, OBJPROP_CORNER, Corner_of_Chart_RIGHT_TOP);
   ObjectSet(Obj0006, OBJPROP_XDISTANCE, Col04x);
   ObjectSet(Obj0006, OBJPROP_YDISTANCE, Col01y); 

    
           ObjectCreate(Obj0007, OBJ_LABEL, 0, 0, 0);
   ObjectSetText(Obj0007, H1_MACD, 40, "Tahoma Narrow",  color_MACDH1);
   ObjectSet(Obj0007, OBJPROP_CORNER, Corner_of_Chart_RIGHT_TOP);
   ObjectSet(Obj0007, OBJPROP_XDISTANCE, Col05x);
   ObjectSet(Obj0007, OBJPROP_YDISTANCE, Col01y); 

          
           ObjectCreate(Obj0008, OBJ_LABEL, 0, 0, 0);
   ObjectSetText(Obj0008, H4_MACD, 40, "Tahoma Narrow",  color_MACDH4);
   ObjectSet(Obj0008, OBJPROP_CORNER, Corner_of_Chart_RIGHT_TOP);
   ObjectSet(Obj0008, OBJPROP_XDISTANCE, Col06x);
   ObjectSet(Obj0008, OBJPROP_YDISTANCE, Col01y);

    
           ObjectCreate(Obj0009, OBJ_LABEL, 0, 0, 0);
   ObjectSetText(Obj0009, D1_MACD, 40, "Tahoma Narrow",  color_MACDD1);
   ObjectSet(Obj0009, OBJPROP_CORNER, Corner_of_Chart_RIGHT_TOP);
   ObjectSet(Obj0009, OBJPROP_XDISTANCE, Col07x);
   ObjectSet(Obj0009, OBJPROP_YDISTANCE, Col01y);
   
    
           ObjectCreate(Obj0010, OBJ_LABEL, 0, 0, 0);
   ObjectSetText(Obj0010, W1_MACD, 40, "Tahoma Narrow",  color_MACDW1);
   ObjectSet(Obj0010, OBJPROP_CORNER, Corner_of_Chart_RIGHT_TOP);
   ObjectSet(Obj0010, OBJPROP_XDISTANCE, Col08x);
   ObjectSet(Obj0010, OBJPROP_YDISTANCE, Col01y);   
   
   
           ObjectCreate(Obj0011, OBJ_LABEL, 0, 0, 0);
   ObjectSetText(Obj0011, MN1_MACD, 40, "Tahoma Narrow",  color_MACDMN1);
   ObjectSet(Obj0011, OBJPROP_CORNER, Corner_of_Chart_RIGHT_TOP);
   ObjectSet(Obj0011, OBJPROP_XDISTANCE, Col09x);
   ObjectSet(Obj0011, OBJPROP_YDISTANCE, Col01y); 
     
   WindowRedraw() ;   
     
     
 //----
   return(0);
  }
//+------------------------------------------------------------------+


int deinit()
  {
//----


deleteObject(); 

//----
   return(0);
  }

//+------------------------------------------------------------------+
  
void deleteObject()
  { 
//ObjectDelete(Obj0001);  
ObjectDelete(Obj0002); 
ObjectDelete(Obj0003); 
ObjectDelete(Obj0004); 
ObjectDelete(Obj0005); 
ObjectDelete(Obj0006); 
ObjectDelete(Obj0007); 
ObjectDelete(Obj0008); 
ObjectDelete(Obj0009); 
ObjectDelete(Obj0010); 
ObjectDelete(Obj0011); 

ObjectDelete(ObjHead01);  
ObjectDelete(ObjHead02); 
ObjectDelete(ObjHead03); 
ObjectDelete(ObjHead04); 
ObjectDelete(ObjHead05); 
ObjectDelete(ObjHead06); 
ObjectDelete(ObjHead07); 
ObjectDelete(ObjHead08); 
ObjectDelete(ObjHead09); 
 
  }
//+------------------------------------------------------------------+

color ColorMACD( string myPair, int myPeriod )  
{


color MA_color;

      
    
double cMACD = iMACD(myPair,myPeriod,fast_ema_period, slow_ema_period, signal_period,PriceField,MODE_MAIN,0) ;

double pMACD = iMACD(myPair,myPeriod,fast_ema_period, slow_ema_period, signal_period,PriceField,MODE_MAIN,1) ; 
   
double cSignal = iMACD(myPair,myPeriod,fast_ema_period, slow_ema_period, signal_period,PriceField,MODE_SIGNAL,0)  ;
double pSignal = iMACD(myPair,myPeriod,fast_ema_period, slow_ema_period, signal_period,PriceField,MODE_SIGNAL,1)  ;
        
xAbove = cMACD > cSignal && pMACD < pSignal ;  
xBelow = cMACD < cSignal && pMACD > pSignal ;  

  
while(true)
{    
   if( cMACD >= 0 ) 
   {
      if( xAbove ) { MA_color = colorXaA ; break ; }
      if( xBelow ) { MA_color = colorXbA ; break ; }
      if( cMACD > pMACD ) { MA_color = colorUpA ; break ; }
      if( cMACD < pMACD ) { MA_color = colorDnA ; break ; }
      MA_color = DarkGreen ; break ;         
   } else 
   {
      if( xAbove ) { MA_color = colorXaB ; break ; }
      if( xBelow ) { MA_color = colorXbB ; break ; }
      if( cMACD > pMACD ) { MA_color = colorUpB ; break ; }
      if( cMACD < pMACD ) { MA_color = colorDnB ; break ; }
      MA_color = Maroon ; break ; 
               
   }   
   
       break ;
  
}  
    
return( MA_color ) ;   
                                    
} //  

 
//+------------------------------------------------------------------+
 
string TimeFrameToString(int tf)
{
   string tfs;
   switch(tf) {
      case PERIOD_M1:  tfs="M1"  ; break;
      case PERIOD_M5:  tfs="M5"  ; break;
      case PERIOD_M15: tfs="M15" ; break;
      case PERIOD_M30: tfs="M30" ; break;
      case PERIOD_H1:  tfs="H1"  ; break;
      case PERIOD_H4:  tfs="H4"  ; break;
      case PERIOD_D1:  tfs="D1"  ; break;
      case PERIOD_W1:  tfs="W1"  ; break;
      case PERIOD_MN1: tfs="MN";
   }
   return(tfs);
}

//+------------------------------------------------------------------+

/*
  
while(true)
{    
   
   if( cMACD >= 0 ) 
   {

      if( cMACD > pMACD   && cMACD > cSignal ) { MA_color = colorUpA ; break ; }
      if( cMACD < pMACD   && cMACD > cSignal ) { MA_color = colorDnA ; break ; }
      if( cMACD > cSignal && pMACD < pSignal ) { MA_color = colorXaA ; break ; }  
      if( cMACD < cSignal && pMACD > pSignal ) { MA_color = colorXbA ; break ; } 
      MA_color = DarkGreen ; break ;         
   } else 
   {

      if( cMACD > pMACD   && cMACD > cSignal ) { MA_color = colorUpB ; break ; }
      if( cMACD < pMACD   && cMACD > cSignal ) { MA_color = colorDnB ; break ; }
      if( cMACD > cSignal && pMACD < pSignal ) { MA_color = colorXaB ; break ; }  
      if( cMACD < cSignal && pMACD > pSignal ) { MA_color = colorXbB ; break ; } 
      MA_color = Maroon ; break ; 
               
   }   
   
       break ;
  
} 

*/